import * as React from 'react';
import {
  Table, Header, Container, Form, Checkbox, Button, Rating,
  List, Icon, Radio, CheckboxProps,
} from 'semantic-ui-react';
import MetaCrawler from '@overflow/meta/api/model/MetaCrawler';



export interface StateProps {
  metaCrawlerList?: Array<MetaCrawler>;
}

export interface DispatchProps {
}

export type Props = StateProps & DispatchProps;

export interface State {
  selectedValue: number | string;
  testMetaCrawlerList: Array<MetaCrawler>;
}

export class SensorConfigCrawler extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);

    this.state = {
      selectedValue: null,
      testMetaCrawlerList: testMetaCrawler,
    };
  }

  public handleChange = (event: React.FormEvent<HTMLInputElement>, data: CheckboxProps) => {
    this.setState({ selectedValue: data.value });
  }


  public renderCrawler(): JSX.Element[] {

    let mcl: Array<MetaCrawler> = this.state.testMetaCrawlerList;


    let elems: JSX.Element[] = new Array();

    let mc: MetaCrawler = null;
    for(let idx: number = 0; idx < mcl.length; idx++) {
      mc = mcl[idx];

      elems.push(
        <Form.Field>
          <Radio
            label={mc.name}
            name='crawlerGroup'
            value={mc.name}
            checked={this.state.selectedValue === mc.name}
            onChange={this.handleChange}
          />
        </Form.Field>,
      );
    }

    return elems;
  }

  public render(): JSX.Element {
    return (
      <Form>
        <Form.Field>
          Selected Crawler : <b>{this.state.selectedValue}</b>
        </Form.Field>
        {this.renderCrawler()}
      </Form>
    );
  }

}


const testMetaCrawler: any[] = [{
  'id': 1,
  'createDate': 1498794968791,
  'name': 'ACTIVEDIRECTORY_CRAWLER',
  'description': 'ACTIVEDIRECTORY',
},
{
  'id': 2,
  'createDate': 1498794968791,
  'name': 'CASSANDRA_CRAWLER',
  'description': 'CASSANDRA',
},
{
  'id': 3,
  'createDate': 1498794968791,
  'name': 'DHCP_CRAWLER',
  'description': 'DHCP',
},
{
  'id': 4,
  'createDate': 1498794968791,
  'name': 'DNS_CRAWLER',
  'description': 'DNS',
},
{
  'id': 5,
  'createDate': 1498794968791,
  'name': 'FTP_CRAWLER',
  'description': 'FTP',
},
{
  'id': 6,
  'createDate': 1498794968791,
  'name': 'HTTP_CRAWLER',
  'description': 'HTTP',
},
{
  'id': 7,
  'createDate': 1498794968791,
  'name': 'IMAP_CRAWLER',
  'description': 'IMAP',
},
{
  'id': 8,
  'createDate': 1498794968791,
  'name': 'LDAP_CRAWLER',
  'description': 'LDAP',
},
{
  'id': 9,
  'createDate': 1498794968791,
  'name': 'MONGODB_CRAWLER',
  'description': 'MONGODB',
},
{
  'id': 10,
  'createDate': 1498794968791,
  'name': 'MSSQL_CRAWLER',
  'description': 'MSSQL',
},
{
  'id': 11,
  'createDate': 1498794968791,
  'name': 'MYSQL_CRAWLER',
  'description': 'MYSQL',
},
{
  'id': 12,
  'createDate': 1498794968791,
  'name': 'NETBIOS_CRAWLER',
  'description': 'NETBIOS',
},
{
  'id': 13,
  'createDate': 1498794968791,
  'name': 'ORACLE_CRAWLER',
  'description': 'ORACLE',
},
{
  'id': 14,
  'createDate': 1498794968791,
  'name': 'POP_CRAWLER',
  'description': 'POP',
},
{
  'id': 15,
  'createDate': 1498794968791,
  'name': 'POSTGRESQL_CRAWLER',
  'description': 'POSTGRESQL',
},
{
  'id': 16,
  'createDate': 1498794968791,
  'name': 'REDIS_CRAWLER',
  'description': 'REDIS',
},
{
  'id': 17,
  'createDate': 1498794968791,
  'name': 'JMX_CRAWLER',
  'description': 'JMX',
},
{
  'id': 18,
  'createDate': 1498794968791,
  'name': 'SMB_CRAWLER',
  'description': 'SMB',
},
{
  'id': 19,
  'createDate': 1498794968791,
  'name': 'SMTP_CRAWLER',
  'description': 'SMTP',
},
{
  'id': 20,
  'createDate': 1498794968791,
  'name': 'SNMP_CRAWLER',
  'description': 'SNMP',
},
{
  'id': 21,
  'createDate': 1498794968791,
  'name': 'SSH_CRAWLER',
  'description': 'SSH',
},
{
  'id': 22,
  'createDate': 1498794968791,
  'name': 'TELNET_CRAWLER',
  'description': 'TELNET',
},
{
  'id': 23,
  'createDate': 1498794968791,
  'name': 'WMI_CRAWLER',
  'description': 'WMI',
},
{
  'id': 24,
  'createDate': 1498794968791,
  'name': 'UNKNOWN_CRAWLER',
  'description': 'UNKNOWN',
},
{
  'id': 25,
  'createDate': 1498794968791,
  'name': 'SNMPV3_CRAWLER',
  'description': 'SNMP V3',
}];
