import * as React from 'react';
import {
  Table, Header, Container, Form, Checkbox, Button, Rating,
  List, Icon, Radio, CheckboxProps, InputOnChangeData, Input,
  Grid,
} from 'semantic-ui-react';
import { Infra } from '@overflow/infra/api/model/Infra';
import { InfraHost } from '@overflow/infra/api/model/InfraHost';

import * as Utils from '@overflow/commons/util/Utils';

export interface StateProps {
}

export interface DispatchProps {
}

export type Props = StateProps & DispatchProps;

export interface State {

}

export class SensorConfigSetting extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);

    this.state = {

    };
  }

  public render(): JSX.Element {
    return (
      <Container>
        <Grid columns={2} divided>
          <Grid.Row>
            <Grid.Column >
              Interval select
        <SensorConfigSettingNameInterval />
            </Grid.Column>
            <Grid.Column>
              Target Info
        <SensorConfigSettingTargetInfo />
            </Grid.Column>
          </Grid.Row>
          <Grid.Row>
            <Grid.Column>
              Sensor Item Info
        <SensorConfigSettingSensorItemInfo />
            </Grid.Column>
          </Grid.Row>
        </Grid>



      </Container>
    );
  }

}




export interface NameIntervalStateProps {
}

export interface NameIntervalDispatchProps {
}

export type NameIntervalProps = NameIntervalStateProps & NameIntervalDispatchProps;

export interface NameIntervalState {
  selectedValue: number | string;
}

export class SensorConfigSettingNameInterval extends React.Component<NameIntervalProps, NameIntervalState> {

  constructor(props: NameIntervalProps, context: NameIntervalState) {
    super(props, context);

    this.state = {
      selectedValue: null,
    };
  }

  public handleChange = (event: React.FormEvent<HTMLInputElement>, data: CheckboxProps) => {
    this.setState({ selectedValue: data.value });
  }


  public render(): JSX.Element {
    return (
      <Container>
        <Input label={'Name'} placeholder={'Sensor 1234'} key={0} onChange={
          (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
            {/* this.onChangeAuth(item.name, data.value); */ }
          }} />
        <Form>
          <Form.Field>
            <Radio
              label='10'
              name='intervalGroup'
              value='10'
              checked={this.state.selectedValue === '10'}
              onChange={this.handleChange}
            />
          </Form.Field>
          <Form.Field>
            <Radio
              label='15'
              name='intervalGroup'
              value='15'
              checked={this.state.selectedValue === '15'}
              onChange={this.handleChange}
            />
          </Form.Field>
          <Form.Field>
            <Radio
              label='20'
              name='intervalGroup'
              value='20'
              checked={this.state.selectedValue === '20'}
              onChange={this.handleChange}
            />
          </Form.Field>
        </Form>
      </Container>
    );
  }

}



export interface TargetInfoStateProps {
}

export interface TargetInfoDispatchProps {
}

export type TargetInfoProps = TargetInfoStateProps & TargetInfoDispatchProps;

export interface TargetInfoState {
  testInfraList: Array<Infra>;
}

export class SensorConfigSettingTargetInfo extends React.Component<TargetInfoProps, TargetInfoState> {

  constructor(props: TargetInfoProps, context: TargetInfoState) {
    super(props, context);

    this.state = {
      testInfraList: testInfraDataList,
    };
  }

  public renderInfra(): JSX.Element[] {

    let infraList: Array<Infra> = this.state.testInfraList;

    if (infraList === undefined || infraList.length <= 0) {
      return null;
    }

    let elems: Array<JSX.Element> = new Array();


    infraList.map((infra: Infra, idx: number) => {
      if (infra.infraType.name === 'HOST') {
        elems.push(
          <SensorConfigSettingTargetInfoHost infraHost={infra} />,
        );
      } else if (infra.infraType.name === 'OS_SERVICE') {
        // elems.push(
        // );
      }
    });

    return elems;
  }

  public render(): JSX.Element {
    return (
      <Container>
        {this.renderInfra()}
      </Container>
    );
  }

}


export interface TargetInfoHostStateProps {
  infraHost: InfraHost;
}

export interface TargetInfoHostDispatchProps {
}

export type TargetInfoHostProps = TargetInfoHostStateProps & TargetInfoHostDispatchProps;

export interface TargetInfoHostState {

}

export class SensorConfigSettingTargetInfoHost extends React.Component<TargetInfoHostProps, TargetInfoHostState> {

  constructor(props: TargetInfoHostProps, context: TargetInfoHostState) {
    super(props, context);

    this.state = {

    };
  }

  public renderInfraHost(): JSX.Element[] {

    if (this.props.infraHost === undefined || this.props.infraHost === null) {
      return null;
    }

    let ih: InfraHost = this.props.infraHost;

    let elems: Array<JSX.Element> = new Array();

    elems.push(
      <Table celled={false} >
        <Table.Body>
          <Table.Row>
            <Table.Cell collapsing>
              <Header size='small'>os vendor</Header>
            </Table.Cell>
            <Table.Cell>
              {ih.os.vendor.name}
            </Table.Cell>
          </Table.Row>
          <Table.Row>
            <Table.Cell collapsing>
              <Header size='small'>meta info</Header>
            </Table.Cell>
            <Table.Cell>
              {ih.os.meta}
            </Table.Cell>
          </Table.Row>
          <Table.Row>
            <Table.Cell collapsing>
              <Header size='small'>IP</Header>
            </Table.Cell>
            <Table.Cell>
              {Utils.int2ip(ih.ip)}
            </Table.Cell>
          </Table.Row>
          <Table.Row>
            <Table.Cell collapsing>
              <Header size='small'>mac</Header>
            </Table.Cell>
            <Table.Cell>
              {Utils.intToMac(ih.mac)}
            </Table.Cell>
          </Table.Row>
        </Table.Body>
      </Table>,
    );

    return elems;
  }

  public render(): JSX.Element {
    return (
      <Container>
        {this.renderInfraHost()}
      </Container>
    );
  }

}




export interface SensorItemInfoStateProps {
}

export interface SensorItemInfoDispatchProps {
}

export type SensorItemInfoProps = SensorItemInfoStateProps & SensorItemInfoDispatchProps;

export interface SensorItemInfoState {
  testSensorItemList: Array<any>;
}

export class SensorConfigSettingSensorItemInfo extends React.Component<SensorItemInfoProps, SensorItemInfoState> {

  constructor(props: SensorItemInfoProps, context: SensorItemInfoState) {
    super(props, context);

    this.state = {
      testSensorItemList: new Array(),
    };

    this.testCreateData();
  }


  public testCreateData(): void {

    this.state.testSensorItemList.push({ key: 'CPU Total Usage', unit: '%', realKey: 'wmi.cpu.usage.total' });
    this.state.testSensorItemList.push({ key: 'CPU Free Usage', unit: 'kb', realKey: 'wmi.cpu.usage.free' });
    this.state.testSensorItemList.push({ key: 'Mem Total Usage', unit: '%', realKey: 'wmi.mem.usage.total' });
  }

  public renderSensorItem(): JSX.Element[] {

    let elems: Array<JSX.Element> = new Array();


    this.state.testSensorItemList.map((data: any, idx: number) => {
      elems.push(
        <Table.Row key={'sil' + String(idx)}>
          <Table.Cell collapsing>
            {data.key} ({data.unit})
            </Table.Cell>
          <Table.Cell>
            {data.realKey}
          </Table.Cell>
          <Table.Cell>
            [Add Notification]
            </Table.Cell>
        </Table.Row>,
        <Table.Row key={'siladd' + String(idx)}>
          <Table.Cell>
            <input type='text' placeholder='MIN' />
            <input type='text' placeholder='MAX' />
            <Checkbox label={{ children: 'local push' }} />
            <Checkbox label={{ children: 'email' }} />
            <Checkbox label={{ children: 'sms' }} />
          </Table.Cell>
        </Table.Row>,
      );
    });

    return elems;
  }

  public render(): JSX.Element {
    return (
      <Container>
        <Table celled={false}>
          <Table.Body>
            {this.renderSensorItem()}
          </Table.Body>
        </Table>
      </Container>
    );
  }

}



const testInfraDataList: any[] = [
  {
    'id': 4,
    'infraType': {
      'id': 7,
      'name': 'OS_SERVICE',
      'createDate': 1498379502906,
    },
    'createDate': 1503293066525,
    'probe': {
      'id': 1,
      'status': {
        'id': 1,
        'name': 'INITIAL',
      },
      'description': 'snoop probe',
      'createDate': 1503294511563,
      'domain': {
        'id': 1,
        'name': "overFlow's domain",
        'createDate': 1498443944866,
      },
      'probeKey': '899fdd145bcc11e7b611080027658d13',
      'encryptionKey': '8c51fa9c5bcc11e7980a080027658d13',
      'displayName': 'test probe 111111',
      'cidr': '192.168.1.0/24',
      'authorizeDate': 1503294511563,
      'authorizeMember': {
        'id': 1,
        'email': 'overflow@loafle.com',
        'name': 'overFlow',
        'phone': '000-000-0000',
        'companyName': 'loafle',
        'createDate': 1498442847625,
        'status': {
          'id': 2,
          'name': 'NORMAL',
        },
        'signinFailCount': 0,
      },
      'targets': null,
    },
    'target': {
      'id': 4,
      'createDate': 1501154289555,
      'displayName': 'ghost target',
      'description': 'Service target',
      'sensors': [{
        'id': 3,
        'createDate': 1503904625506,
        'description': 'OS_SERVICE-MYSQL_CRAWLER',
        'status': {
          'id': 1,
          'name': 'RUNNING',
        },
        'target': {
          'id': 4,
          'createDate': 1501154289555,
          'displayName': 'ghost target',
          'description': 'Service target',
          'sensors': null,
        },
        'crawler': {
          'id': 11,
          'createDate': 1498794968791,
          'name': 'MYSQL_CRAWLER',
          'description': 'MYSQL',
        },
        'crawlerInputItems': null,
        'itemCount': 2,
      },
      {
        'id': 5,
        'createDate': 1505100362738,
        'description': 'SERVICE-JMX_CRAWLER',
        'status': {
          'id': 1,
          'name': 'RUNNING',
        },
        'target': {
          'id': 4,
          'createDate': 1501154289555,
          'displayName': 'ghost target',
          'description': 'Service target',
          'sensors': null,
        },
        'crawler': {
          'id': 17,
          'createDate': 1498794968791,
          'name': 'JMX_CRAWLER',
          'description': 'JMX',
        },
        'crawlerInputItems': null,
        'itemCount': 4,
      }],
    },
    'host': {
      'id': 3,
      'infraType': {
        'id': 2,
        'name': 'HOST',
        'createDate': 1498379502894,
      },
      'createDate': 1503292801830,
      'probe': {
        'id': 1,
        'status': {
          'id': 1,
          'name': 'INITIAL',
        },
        'description': 'snoop probe',
        'createDate': 1503294511563,
        'domain': {
          'id': 1,
          'name': "overFlow's domain",
          'createDate': 1498443944866,
        },
        'probeKey': '899fdd145bcc11e7b611080027658d13',
        'encryptionKey': '8c51fa9c5bcc11e7980a080027658d13',
        'displayName': 'test probe 111111',
        'cidr': '192.168.1.0/24',
        'authorizeDate': 1503294511563,
        'authorizeMember': {
          'id': 1,
          'email': 'overflow@loafle.com',
          'name': 'overFlow',
          'phone': '000-000-0000',
          'companyName': 'loafle',
          'createDate': 1498442847625,
          'status': {
            'id': 2,
            'name': 'NORMAL',
          },
          'signinFailCount': 0,
        },
        'targets': null,
      },
      'target': {
        'id': 3,
        'createDate': 1501154289555,
        'displayName': 'ghost target',
        'description': 'Host target',
        'sensors': [{
          'id': 4,
          'createDate': 1504581962738,
          'description': 'HOST-WMI_CRAWLER',
          'status': {
            'id': 1,
            'name': 'RUNNING',
          },
          'target': {
            'id': 3,
            'createDate': 1501154289555,
            'displayName': 'ghost target',
            'description': 'Host target',
            'sensors': null,
          },
          'crawler': {
            'id': 23,
            'createDate': 1498794968791,
            'name': 'WMI_CRAWLER',
            'description': 'WMI',
          },
          'crawlerInputItems': null,
          'itemCount': 1,
        }],
      },
      'os': {
        'id': 2,
        'infraType': {
          'id': 3,
          'name': 'OS',
          'createDate': 1498379502906,
        },
        'createDate': 1503288324883,
        'probe': {
          'id': 1,
          'status': {
            'id': 1,
            'name': 'INITIAL',
          },
          'description': 'snoop probe',
          'createDate': 1503294511563,
          'domain': {
            'id': 1,
            'name': "overFlow's domain",
            'createDate': 1498443944866,
          },
          'probeKey': '899fdd145bcc11e7b611080027658d13',
          'encryptionKey': '8c51fa9c5bcc11e7980a080027658d13',
          'displayName': 'test probe 111111',
          'cidr': '192.168.1.0/24',
          'authorizeDate': 1503294511563,
          'authorizeMember': {
            'id': 1,
            'email': 'overflow@loafle.com',
            'name': 'overFlow',
            'phone': '000-000-0000',
            'companyName': 'loafle',
            'createDate': 1498442847625,
            'status': {
              'id': 2,
              'name': 'NORMAL',
            },
            'signinFailCount': 0,
          },
          'targets': null,
        },
        'target': {
          'id': 2,
          'createDate': 1501154289555,
          'displayName': 'ghost target',
          'description': 'OS target',
          'sensors': [],
        },
        'machine': {
          'id': 1,
          'infraType': {
            'id': 1,
            'name': 'MACHINE',
            'createDate': 1498379502770,
          },
          'createDate': 1503287950244,
          'probe': {
            'id': 1,
            'status': {
              'id': 1,
              'name': 'INITIAL',
            },
            'description': 'snoop probe',
            'createDate': 1503294511563,
            'domain': {
              'id': 1,
              'name': "overFlow's domain",
              'createDate': 1498443944866,
            },
            'probeKey': '899fdd145bcc11e7b611080027658d13',
            'encryptionKey': '8c51fa9c5bcc11e7980a080027658d13',
            'displayName': 'test probe 111111',
            'cidr': '192.168.1.0/24',
            'authorizeDate': 1503294511563,
            'authorizeMember': {
              'id': 1,
              'email': 'overflow@loafle.com',
              'name': 'overFlow',
              'phone': '000-000-0000',
              'companyName': 'loafle',
              'createDate': 1498442847625,
              'status': {
                'id': 2,
                'name': 'NORMAL',
              },
              'signinFailCount': 0,
            },
            'targets': null,
          },
          'target': {
            'id': 1,
            'createDate': 1501154289555,
            'displayName': 'ghost target',
            'description': 'Machine Target',
            'sensors': [{
              'id': 1,
              'createDate': 1498475947009,
              'description': 'My sensor 11111',
              'status': {
                'id': 1,
                'name': 'RUNNING',
              },
              'target': {
                'id': 1,
                'createDate': 1501154289555,
                'displayName': 'ghost target',
                'description': 'Machine Target',
                'sensors': null,
              },
              'crawler': {
                'id': 1,
                'createDate': 1498794968791,
                'name': 'ACTIVEDIRECTORY_CRAWLER',
                'description': 'ACTIVEDIRECTORY',
              },
              'crawlerInputItems': null,
              'itemCount': 3,
            },
            {
              'id': 2,
              'createDate': 1498475947074,
              'description': 'My sensor 22222',
              'status': {
                'id': 2,
                'name': 'STOPPED',
              },
              'target': {
                'id': 1,
                'createDate': 1501154289555,
                'displayName': 'ghost target',
                'description': 'Machine Target',
                'sensors': null,
              },
              'crawler': {
                'id': 1,
                'createDate': 1498794968791,
                'name': 'ACTIVEDIRECTORY_CRAWLER',
                'description': 'ACTIVEDIRECTORY',
              },
              'crawlerInputItems': null,
              'itemCount': 1,
            }],
          },
          'meta': 'i am a infra machine',
        },
        'meta': '',
        'vendor': {
          'id': 24,
          'name': 'UNKNOWN',
          'createDate': 1501136812985,
          'infraType': {
            'id': 7,
            'name': 'OS_SERVICE',
            'createDate': 1498379502906,
          },
        },
      },
      'ip': 3232235980,
      'mac': 8796753988883,
    },
    'portType': 'TCP',
    'port': 80,
    'vendor': {
      'id': 24,
      'name': 'UNKNOWN',
      'createDate': 1501136812985,
      'infraType': {
        'id': 7,
        'name': 'OS_SERVICE',
        'createDate': 1498379502906,
      },
    },
    'tlsType': false,
  },
  {
    'id': 3,
    'infraType': {
      'id': 2,
      'name': 'HOST',
      'createDate': 1498379502894,
    },
    'createDate': 1503292801830,
    'probe': {
      'id': 1,
      'status': {
        'id': 1,
        'name': 'INITIAL',
      },
      'description': 'snoop probe',
      'createDate': 1503294511563,
      'domain': {
        'id': 1,
        'name': "overFlow's domain",
        'createDate': 1498443944866,
      },
      'probeKey': '899fdd145bcc11e7b611080027658d13',
      'encryptionKey': '8c51fa9c5bcc11e7980a080027658d13',
      'displayName': 'test probe 111111',
      'cidr': '192.168.1.0/24',
      'authorizeDate': 1503294511563,
      'authorizeMember': {
        'id': 1,
        'email': 'overflow@loafle.com',
        'name': 'overFlow',
        'phone': '000-000-0000',
        'companyName': 'loafle',
        'createDate': 1498442847625,
        'status': {
          'id': 2,
          'name': 'NORMAL',
        },
        'signinFailCount': 0,
      },
      'targets': null,
    },
    'target': {
      'id': 3,
      'createDate': 1501154289555,
      'displayName': 'ghost target',
      'description': 'Host target',
      'sensors': [{
        'id': 4,
        'createDate': 1504581962738,
        'description': 'HOST-WMI_CRAWLER',
        'status': {
          'id': 1,
          'name': 'RUNNING',
        },
        'target': {
          'id': 3,
          'createDate': 1501154289555,
          'displayName': 'ghost target',
          'description': 'Host target',
          'sensors': null,
        },
        'crawler': {
          'id': 23,
          'createDate': 1498794968791,
          'name': 'WMI_CRAWLER',
          'description': 'WMI',
        },
        'crawlerInputItems': null,
        'itemCount': 1,
      }],
    },
    'os': {
      'id': 2,
      'infraType': {
        'id': 3,
        'name': 'OS',
        'createDate': 1498379502906,
      },
      'createDate': 1503288324883,
      'probe': {
        'id': 1,
        'status': {
          'id': 1,
          'name': 'INITIAL',
        },
        'description': 'snoop probe',
        'createDate': 1503294511563,
        'domain': {
          'id': 1,
          'name': "overFlow's domain",
          'createDate': 1498443944866,
        },
        'probeKey': '899fdd145bcc11e7b611080027658d13',
        'encryptionKey': '8c51fa9c5bcc11e7980a080027658d13',
        'displayName': 'test probe 111111',
        'cidr': '192.168.1.0/24',
        'authorizeDate': 1503294511563,
        'authorizeMember': {
          'id': 1,
          'email': 'overflow@loafle.com',
          'name': 'overFlow',
          'phone': '000-000-0000',
          'companyName': 'loafle',
          'createDate': 1498442847625,
          'status': {
            'id': 2,
            'name': 'NORMAL',
          },
          'signinFailCount': 0,
        },
        'targets': null,
      },
      'target': {
        'id': 2,
        'createDate': 1501154289555,
        'displayName': 'ghost target',
        'description': 'OS target',
        'sensors': [],
      },
      'machine': {
        'id': 1,
        'infraType': {
          'id': 1,
          'name': 'MACHINE',
          'createDate': 1498379502770,
        },
        'createDate': 1503287950244,
        'probe': {
          'id': 1,
          'status': {
            'id': 1,
            'name': 'INITIAL',
          },
          'description': 'snoop probe',
          'createDate': 1503294511563,
          'domain': {
            'id': 1,
            'name': "overFlow's domain",
            'createDate': 1498443944866,
          },
          'probeKey': '899fdd145bcc11e7b611080027658d13',
          'encryptionKey': '8c51fa9c5bcc11e7980a080027658d13',
          'displayName': 'test probe 111111',
          'cidr': '192.168.1.0/24',
          'authorizeDate': 1503294511563,
          'authorizeMember': {
            'id': 1,
            'email': 'overflow@loafle.com',
            'name': 'overFlow',
            'phone': '000-000-0000',
            'companyName': 'loafle',
            'createDate': 1498442847625,
            'status': {
              'id': 2,
              'name': 'NORMAL',
            },
            'signinFailCount': 0,
          },
          'targets': null,
        },
        'target': {
          'id': 1,
          'createDate': 1501154289555,
          'displayName': 'ghost target',
          'description': 'Machine Target',
          'sensors': [{
            'id': 1,
            'createDate': 1498475947009,
            'description': 'My sensor 11111',
            'status': {
              'id': 1,
              'name': 'RUNNING',
            },
            'target': {
              'id': 1,
              'createDate': 1501154289555,
              'displayName': 'ghost target',
              'description': 'Machine Target',
              'sensors': null,
            },
            'crawler': {
              'id': 1,
              'createDate': 1498794968791,
              'name': 'ACTIVEDIRECTORY_CRAWLER',
              'description': 'ACTIVEDIRECTORY',
            },
            'crawlerInputItems': null,
            'itemCount': 3,
          },
          {
            'id': 2,
            'createDate': 1498475947074,
            'description': 'My sensor 22222',
            'status': {
              'id': 2,
              'name': 'STOPPED',
            },
            'target': {
              'id': 1,
              'createDate': 1501154289555,
              'displayName': 'ghost target',
              'description': 'Machine Target',
              'sensors': null,
            },
            'crawler': {
              'id': 1,
              'createDate': 1498794968791,
              'name': 'ACTIVEDIRECTORY_CRAWLER',
              'description': 'ACTIVEDIRECTORY',
            },
            'crawlerInputItems': null,
            'itemCount': 1,
          }],
        },
        'meta': 'i am a infra machine',
      },
      'meta': '',
      'vendor': {
        'id': 24,
        'name': 'UNKNOWN',
        'createDate': 1501136812985,
        'infraType': {
          'id': 7,
          'name': 'OS_SERVICE',
          'createDate': 1498379502906,
        },
      },
    },
    'ip': 3232235980,
    'mac': 8796753988883,
  },
];
